HDU 1150 Machine Schedule(最小点覆盖)

HDU 1150 Machine Schedule(最小点覆盖)

Time Limit:1000MS Memory Limit:10000KB

Description

As we all know, machine scheduling is a very classical problem in computer science and has been studied for a very long history. Scheduling problems differ widely in the nature of the constraints that must be satisfied and the type of schedule desired. Here we consider a 2-machine scheduling problem.

There are two machines A and B. Machine A has n kinds of working modes, which is called mode_0, mode_1, …, mode_n-1, likewise machine B has m kinds of working modes, mode_0, mode_1, … , mode_m-1. At the beginning they are both work at mode_0.

For k jobs given, each of them can be processed in either one of the two machines in particular mode. For example, job 0 can either be processed in machine A at mode_3 or in machine B at mode_4, job 1 can either be processed in machine A at mode_2 or in machine B at mode_4, and so on. Thus, for job i, the constraint can be represent as a triple (i, x, y), which means it can be processed either in machine A at mode_x, or in machine B at mode_y.

Obviously, to accomplish all the jobs, we need to change the machine’s working mode from time to time, but unfortunately, the machine’s working mode can only be changed by restarting it manually. By changing the sequence of the jobs and assigning each job to a suitable machine, please write a program to minimize the times of restarting machines.

Input

The input file for this program consists of several configurations. The first line of one configuration contains three positive integers: n, m (n, m < 100) and k (k < 1000). The following k lines give the constrains of the k jobs, each line is a triple: i, x, y.

The input will be terminated by a line containing a single zero.

Output

The output should be one integer per line, which means the minimal times of restarting machine.

Sample Input

5 5 10
0 1 1
1 1 2
2 1 3
3 1 4
4 2 1
5 2 2
6 2 3
7 2 4
8 3 3
9 4 3
0

Sample Output

3

传送门
一句话题意:给出一个二分图,求它的最小点覆盖。
蒟蒻拿到本题的时候根本不知道二分图的最小点覆盖就是它的最大匹配,想了很久……

下面给出一个简单的证明:
对于所有最大匹配中的边的一对端点, 一定最多只有一个点含有不在最大匹配中的临接点,在覆盖的时候我们就选择这个点,所以证出最大匹配数的范围内一定可以覆盖完整个图。又每一个匹配的边的端点最优情况下只能被另一个端点或自己覆盖, 所以,最少覆盖也需要最大匹配数这么多的点。即最大匹配数<=最小点覆盖数<=最大匹配数。导出最小点覆盖数 == 最大匹配数
好了, 给出代码。

#include<cstdio>
#include<cstring>
#define MAXM 10000
#define MAXN 300
int n, m, k, c[MAXN];
bool vis[MAXN];
struct node
{
    int v;
    node *next;
}Edge[MAXM], *Adj[MAXN], *Mcnt = Edge;
void Addedge(int u, int v)
{
    node *t = ++Mcnt;
    t->v = v;
    t->next = Adj[u];
    Adj[u] = t;
}
bool dfs(int u)
{
    vis[u] = 1;
    for(node *p = Adj[u]; p; p = p->next)
    {
        if(!vis[p->v]){
            vis[p->v] = 1;
            if(!c[p->v] || dfs(c[p->v]))
            {
                c[u] = p->v;
                c[p->v] = u;
                return 1;
            }
        }
    }
    return 0;
}
int main()
{
    int k;
    int i,u,v;
    while(scanf("%d",&n),n)
    {
        Mcnt = Edge;
        scanf("%d%d",&m,&k);
        memset(Edge, 0, sizeof Edge);
        memset(Adj, 0, sizeof Adj);
        while(k--)
        {
            scanf("%d%d%d",&i,&u,&v);
            if(u>0&&v>0)Addedge(u, v + n);
        }
        int ans=0;
        int u;
        memset(c, 0, sizeof c);
        for(u = 0; u < n; u ++)
        {
            memset(vis,0,sizeof vis);
            ans += dfs(u);
        }
        printf("%d\n", ans);
    }
    return 0;
}

你可能感兴趣的:(HDU,二分图,匈牙利算法)